using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace ArrowsCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.TextBox txtY;
		internal System.Windows.Forms.TextBox txtX;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Panel1 = new System.Windows.Forms.Panel();
			this.txtY = new System.Windows.Forms.TextBox();
			this.txtX = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// Panel1
			// 
			this.Panel1.BackColor = System.Drawing.Color.White;
			this.Panel1.Location = new System.Drawing.Point(24, 24);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(200, 168);
			this.Panel1.TabIndex = 2;
			this.Panel1.TabStop = true;
			this.Panel1.Click += new System.EventHandler(this.Panel1_Click);
			// 
			// txtY
			// 
			this.txtY.Location = new System.Drawing.Point(248, 72);
			this.txtY.Name = "txtY";
			this.txtY.Size = new System.Drawing.Size(72, 20);
			this.txtY.TabIndex = 4;
			this.txtY.Text = "";
			this.txtY.Leave += new System.EventHandler(this.txtY_Leave);
			// 
			// txtX
			// 
			this.txtX.Location = new System.Drawing.Point(248, 40);
			this.txtX.Name = "txtX";
			this.txtX.Size = new System.Drawing.Size(72, 20);
			this.txtX.TabIndex = 3;
			this.txtX.Text = "";
			this.txtX.Leave += new System.EventHandler(this.txtX_Leave);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 221);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtY,
																		  this.txtX,
																		  this.Panel1});
			this.Name = "Form1";
			this.Text = "Arrow Catcher";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.Form1_KeyDown);
			this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.Form1_KeyPress);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion


		int CurrentX, CurrentY;

		void SetPosition(int NewX, int NewY, bool Draw) 
		{

			if (NewX > Panel1.Width)  NewX = Panel1.Width;

			if (NewY > Panel1.Height)  NewY = Panel1.Height;
			if (NewX < 0) NewX = 0;
			if (NewY < 0)  NewY = 0;
																												 
			if (Draw) 
			{
				Graphics g = Panel1.CreateGraphics();
				g.DrawLine(Pens.Blue, CurrentX, CurrentY, NewX, NewY);
				g.Dispose();
			}
			CurrentX = NewX;
			CurrentY = NewY;
		}


		private void txtX_Leave(object sender, System.EventArgs e)
		{
			int newx;
			try 
			{
				newx = int.Parse(txtX.Text);
				SetPosition(newx, CurrentY, false);
			}
			catch 
			{
				txtX.Text = CurrentX.ToString();
			}

		}

		private void txtY_Leave(object sender, System.EventArgs e)
		{
			int newy ;
			try 
			{
				newy = int.Parse(txtY.Text);
				SetPosition(CurrentX, newy, false);
				// Panel1.Select() ' But what about a mouse click?
			}
			catch 
			{
				txtY.Text = CurrentY.ToString();
			}
		
		}


		private void Form1_Load(object sender, System.EventArgs e)
		{
			CurrentX = Panel1.Width / 2;
			CurrentY = Panel1.Height / 2;
			txtX.Text = CurrentX.ToString();
			txtY.Text = CurrentY.ToString();
			Panel1.Select();
		
		}

		private void Form1_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
		        Debug.WriteLine(e.KeyChar);

		}

		private void Form1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
		        Debug.WriteLine(e.KeyCode);

		}

		private void Panel1_Click(object sender, System.EventArgs e)
		{
        Panel1.Select();
		
		}

		protected override bool ProcessDialogKey(System.Windows.Forms.Keys keyData)
		{
			if (ActiveControl == Panel1) 
			{
				// Ignore arrows
				switch(keyData) 
				{
					case Keys.Left:
						SetPosition(CurrentX - 10, CurrentY, true);
						return true;
					case Keys.Right:
						SetPosition(CurrentX + 10, CurrentY, true);
						return true;
					case Keys.Up:
						SetPosition(CurrentX, CurrentY - 10, true);
						return true;
					case Keys.Down:
						SetPosition(CurrentX, CurrentY + 10, true);
						return true;
				}
			}
			// Allow tab to the panel
			if (ActiveControl == txtY ) 
			{
				switch( keyData) 
				{
					case Keys.Tab:
						Panel1.Select();
						return true;
				}
			}
			return base.ProcessDialogKey(keyData);
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

	

	}
}
