// Control array example
// Copyright 2002-2003 by Dan Appleman

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;

namespace ControlArraysCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuCreate;
		private System.Windows.Forms.MenuItem mnuDelete;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuCreate = new System.Windows.Forms.MenuItem();
			this.mnuDelete = new System.Windows.Forms.MenuItem();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 184);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(368, 24);
			this.label1.TabIndex = 0;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuCreate,
																					  this.mnuDelete});
			this.menuItem1.Text = "Controls";
			// 
			// mnuCreate
			// 
			this.mnuCreate.Index = 0;
			this.mnuCreate.Text = "Create";
			this.mnuCreate.Click += new System.EventHandler(this.mnuCreate_Click);
			// 
			// mnuDelete
			// 
			this.mnuDelete.Index = 1;
			this.mnuDelete.Text = "Delete";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(256, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 221);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.label1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Control Arrays";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private ArrayList Buttons = new ArrayList();

		private void button1_Click(object sender, System.EventArgs e)
		{
			Control ctl = (Control)sender;
			label1.Text = ctl.Name + " was clicked";
		}

		String[] DontCopyNames = {"WindowTarget"};

		private void CopyProperties(Control source, Control Dest) 
		{
			PropertyInfo[] pinfos;
			Object obj;
			pinfos = source.GetType().GetProperties();
			foreach(PropertyInfo pinfo in pinfos) 
			{
				if (pinfo.GetIndexParameters().Length == 0 ) 
				{
					if ( Array.IndexOf(DontCopyNames, pinfo.Name) < 0 ) 
					{ 
						if ( pinfo.CanRead && pinfo.CanWrite) 
						{
							// Debug.WriteLine(pinfo.Name )
							obj = pinfo.GetValue(source, null);
							pinfo.SetValue(Dest, obj, null);
						}
					}
				}
			}
		}

		private void mnuCreate_Click(object sender, System.EventArgs e)
		{
			Button NewButton = new Button();
			int ButtonNumber;
			CopyProperties(button1, NewButton);
			Controls.Add(NewButton);
			NewButton.Click += new EventHandler(button1_Click);
			ButtonNumber = Buttons.Count;
			NewButton.Name = "New Button " + ButtonNumber.ToString();
			NewButton.Text = NewButton.Name;
			NewButton.Top = NewButton.Top + NewButton.Height * (ButtonNumber + 1);
			Buttons.Add(NewButton);
  
		}

		private void mnuDelete_Click(object sender, System.EventArgs e)
		{
			Button KillButton;
			if(Buttons.Count == 0) return;
			KillButton = (Button)(Buttons[Buttons.Count - 1]);
			Buttons.Remove(KillButton);
			KillButton.Click -= new EventHandler(button1_Click);
			Controls.Remove(KillButton);

		}

	}
}
