' Cryptography example
' Copyright 2002-2003 by Dan Appleman
Imports System.Security.Cryptography
Imports System.IO
Imports System.Text

Public Class frmCryptoMain
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtSource As System.Windows.Forms.TextBox
    Friend WithEvents txtEncrypted As System.Windows.Forms.TextBox
    Friend WithEvents txtResult As System.Windows.Forms.TextBox
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuSymDecrypt As System.Windows.Forms.MenuItem

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents mnuSymmetrical As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtSource = New System.Windows.Forms.TextBox()
        Me.txtEncrypted = New System.Windows.Forms.TextBox()
        Me.txtResult = New System.Windows.Forms.TextBox()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.MenuItem1 = New System.Windows.Forms.MenuItem()
        Me.mnuSymmetrical = New System.Windows.Forms.MenuItem()
        Me.mnuSymDecrypt = New System.Windows.Forms.MenuItem()
        Me.SuspendLayout()
        '
        'txtSource
        '
        Me.txtSource.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtSource.Location = New System.Drawing.Point(16, 24)
        Me.txtSource.Multiline = True
        Me.txtSource.Name = "txtSource"
        Me.txtSource.Size = New System.Drawing.Size(312, 80)
        Me.txtSource.TabIndex = 0
        Me.txtSource.Text = "This is some sample text that will be encrypted."
        '
        'txtEncrypted
        '
        Me.txtEncrypted.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtEncrypted.Location = New System.Drawing.Point(16, 112)
        Me.txtEncrypted.Multiline = True
        Me.txtEncrypted.Name = "txtEncrypted"
        Me.txtEncrypted.Size = New System.Drawing.Size(312, 64)
        Me.txtEncrypted.TabIndex = 1
        Me.txtEncrypted.Text = ""
        '
        'txtResult
        '
        Me.txtResult.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtResult.Location = New System.Drawing.Point(16, 184)
        Me.txtResult.Multiline = True
        Me.txtResult.Name = "txtResult"
        Me.txtResult.Size = New System.Drawing.Size(312, 72)
        Me.txtResult.TabIndex = 2
        Me.txtResult.Text = ""
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuSymmetrical, Me.mnuSymDecrypt})
        Me.MenuItem1.Text = "Tests"
        '
        'mnuSymmetrical
        '
        Me.mnuSymmetrical.Index = 0
        Me.mnuSymmetrical.Text = "Symmetrical Encrypt"
        '
        'mnuSymDecrypt
        '
        Me.mnuSymDecrypt.Index = 1
        Me.mnuSymDecrypt.Text = "Symmetrical Decrypt"
        '
        'frmCryptoMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(344, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtResult, Me.txtEncrypted, Me.txtSource})
        Me.Menu = Me.MainMenu1
        Me.Name = "frmCryptoMain"
        Me.Text = "Cryptography Test"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Stream to hold encrypted data
    Private EncryptedStream As MemoryStream
    Private InitializationVector() As Byte
    Private Salt(16) As Byte

    Private Sub mnuSymmetrical_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSymmetrical.Click
        Dim pw As String

        ' Set up the RC2 encryptor
        Dim rc2use As RC2 = RC2.Create()
        InitializationVector = rc2use.IV

        Dim rng As New RNGCryptoServiceProvider()
        rng.GetBytes(Salt)

        ' Derive a password
        pw = InputBox("Enter password", "Password")
        Dim pdbkey As PasswordDeriveBytes = New PasswordDeriveBytes(pw, Salt)

        Dim key() As Byte
        key = pdbkey.CryptDeriveKey("RC2", pdbkey.HashName, 128, rc2use.IV)

        rc2use.Key = key

        ' Encrypt into EncryptedStream, using a StreamWriter
        If Not EncryptedStream Is Nothing Then EncryptedStream.Close()

        EncryptedStream = New MemoryStream()
        Dim cstream As CryptoStream = New CryptoStream(EncryptedStream, rc2use.CreateEncryptor(), CryptoStreamMode.Write)

        Dim swriter As New StreamWriter(cstream)
        swriter.WriteLine(txtSource.Text)
        swriter.Flush()
        cstream.FlushFinalBlock()
        cstream.Flush()
        EncryptedStream.Flush()

        ' Read the data from the stream to display
        EncryptedStream.Seek(0, SeekOrigin.Begin)

        Dim encdata() As Byte
        Dim x, bytesread As Integer
        ReDim encdata(CInt(EncryptedStream.Length) - 1)
        bytesread = CInt(EncryptedStream.Read(encdata, 0, CInt(EncryptedStream.Length)))
        Dim sb As New StringBuilder()
        For x = 0 To bytesread - 1
            sb.Append(Hex(encdata(x)))
            sb.Append(" ")
        Next x
        txtEncrypted.Text = sb.ToString
        swriter.Close()
    End Sub

    Private Sub mnuSymDecrypt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSymDecrypt.Click
        Dim pw As String

        If EncryptedStream Is Nothing Then
            MsgBox("You must encrypt a string first")
            Exit Sub
        End If

        ' Decrypt into another memory stream
        Dim DecryptedStream As New MemoryStream()

        ' Same setup as earlier, except use existing salt and iv
        Dim rc2use As RC2 = RC2.Create()
        pw = InputBox("Enter password", "Password")
        Dim pdbkey As PasswordDeriveBytes = New PasswordDeriveBytes(pw, Salt)

        Dim key() As Byte
        rc2use.IV = InitializationVector
        key = pdbkey.CryptDeriveKey("RC2", pdbkey.HashName, 128, rc2use.IV)

        rc2use.Key = key

        Dim cstream As CryptoStream = New CryptoStream(DecryptedStream, rc2use.CreateDecryptor, CryptoStreamMode.Write)

        Dim EncryptedData() As Byte

        ' Dump encrypted data into decrypted stream.
        EncryptedData = EncryptedStream.ToArray()
        Try
            cstream.Write(EncryptedData, 0, EncryptedData.Length)
            cstream.Flush()
            cstream.FlushFinalBlock()
        Catch ex As Exception
            MsgBox("Decryption failed " & ex.Message)
        End Try
        DecryptedStream.Seek(0, SeekOrigin.Begin)
        ' Use StreamReader to read to text box
        Dim sreader As New StreamReader(DecryptedStream)
        txtResult.Text = sreader.ReadToEnd()
        sreader.Close()
    End Sub
End Class
