using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Security.Cryptography;
using System.Diagnostics;
using System.Text;

namespace CryptoTestCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmCryptoMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtSource;
		private System.Windows.Forms.TextBox txtEncrypted;
		private System.Windows.Forms.TextBox txtResult;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuSymmetrical;
		private System.Windows.Forms.MenuItem mnuSymDecrypt;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCryptoMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtSource = new System.Windows.Forms.TextBox();
			this.txtEncrypted = new System.Windows.Forms.TextBox();
			this.txtResult = new System.Windows.Forms.TextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuSymmetrical = new System.Windows.Forms.MenuItem();
			this.mnuSymDecrypt = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// txtSource
			// 
			this.txtSource.Location = new System.Drawing.Point(8, 8);
			this.txtSource.Multiline = true;
			this.txtSource.Name = "txtSource";
			this.txtSource.Size = new System.Drawing.Size(328, 72);
			this.txtSource.TabIndex = 0;
			this.txtSource.Text = "This is some sample text that will be encrypted.";
			// 
			// txtEncrypted
			// 
			this.txtEncrypted.Location = new System.Drawing.Point(8, 88);
			this.txtEncrypted.Multiline = true;
			this.txtEncrypted.Name = "txtEncrypted";
			this.txtEncrypted.Size = new System.Drawing.Size(328, 72);
			this.txtEncrypted.TabIndex = 1;
			this.txtEncrypted.Text = "";
			// 
			// txtResult
			// 
			this.txtResult.Location = new System.Drawing.Point(8, 168);
			this.txtResult.Multiline = true;
			this.txtResult.Name = "txtResult";
			this.txtResult.Size = new System.Drawing.Size(328, 72);
			this.txtResult.TabIndex = 2;
			this.txtResult.Text = "";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuSymmetrical,
																					  this.mnuSymDecrypt});
			this.menuItem1.Text = "Tests";
			// 
			// mnuSymmetrical
			// 
			this.mnuSymmetrical.Index = 0;
			this.mnuSymmetrical.Text = "Symmetrical Encrypt";
			this.mnuSymmetrical.Click += new System.EventHandler(this.mnuSymmetrical_Click);
			// 
			// mnuSymDecrypt
			// 
			this.mnuSymDecrypt.Index = 1;
			this.mnuSymDecrypt.Text = "Symmetrical Decrypt";
			this.mnuSymDecrypt.Click += new System.EventHandler(this.mnuSymDecrypt_Click);
			// 
			// frmCryptoMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 253);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtResult,
																		  this.txtEncrypted,
																		  this.txtSource});
			this.Menu = this.mainMenu1;
			this.Name = "frmCryptoMain";
			this.Text = "Cryptography Test";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmCryptoMain());
		}

		// Stream to hold encrypted data
		private MemoryStream EncryptedStream;
		private Byte[] InitializationVector ;
		private Byte[] Salt = new Byte[15];

		private void mnuSymmetrical_Click(object sender, System.EventArgs e)
		{
			string pw;

			// Set up the RC2 encryptor
			RC2 rc2use  = RC2.Create();
			InitializationVector = rc2use.IV;

			RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
			rng.GetBytes(Salt);

			// Derive a password
			pw = Microsoft.VisualBasic.Interaction.InputBox("Enter password", "Password", null, -1, -1);

			//iform.Dispose(); 
			PasswordDeriveBytes pdbkey = new PasswordDeriveBytes(pw, Salt);

			Byte[] key;
			key = pdbkey.CryptDeriveKey("RC2", pdbkey.HashName, 128, rc2use.IV);

			rc2use.Key = key;

			// Encrypt into EncryptedStream, using a StreamWriter
			if ( EncryptedStream != null) EncryptedStream.Close();
			EncryptedStream = new MemoryStream();
			CryptoStream cstream = new CryptoStream(EncryptedStream, rc2use.CreateEncryptor(), CryptoStreamMode.Write);

			StreamWriter swriter = new StreamWriter(cstream);
			swriter.WriteLine(txtSource.Text);
			swriter.Flush();
			cstream.FlushFinalBlock();
			cstream.Flush();
			EncryptedStream.Flush();

			// Read the data from the stream to display
			EncryptedStream.Seek(0, SeekOrigin.Begin);

			Byte[] encdata;
			int x, bytesread;
			encdata = new Byte[EncryptedStream.Length];
			bytesread = EncryptedStream.Read(encdata, 0, (int)EncryptedStream.Length);
			StringBuilder sb = new StringBuilder();
			for(x = 0; x< bytesread; x++) 
			{
				sb.Append(string.Format("{0:X} ", encdata[x]));
			}
			txtEncrypted.Text = sb.ToString();
			swriter.Close();
		}

		private void mnuSymDecrypt_Click(object sender, System.EventArgs e)
		{
			string pw;

			if(EncryptedStream == null) 
			{
				MessageBox.Show("You must encrypt a string first");
				return;
			}

			// Decrypt into another memory stream
			MemoryStream DecryptedStream = new MemoryStream();

			// Same setup as earlier, except use existing salt and iv
			RC2 rc2use = RC2.Create();
			pw = Microsoft.VisualBasic.Interaction.InputBox("Enter password", "Password", null, -1, -1);
			PasswordDeriveBytes pdbkey  = new PasswordDeriveBytes(pw, Salt);

			Byte[] key;
			rc2use.IV = InitializationVector;
			key = pdbkey.CryptDeriveKey("RC2", pdbkey.HashName, 128, rc2use.IV);

			rc2use.Key = key;

			CryptoStream cstream  = new CryptoStream(DecryptedStream, rc2use.CreateDecryptor(), CryptoStreamMode.Write);

			Byte[] EncryptedData;

			// Dump encrypted data into decrypted stream.
			EncryptedData = EncryptedStream.ToArray();
			try 
			{
				cstream.Write(EncryptedData, 0, EncryptedData.Length);
				cstream.Flush();
				cstream.FlushFinalBlock();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Decryption failed " + ex.Message);
			}
			DecryptedStream.Seek(0, SeekOrigin.Begin);
			// Use StreamReader to read to text box
			StreamReader sreader = new StreamReader(DecryptedStream);
			txtResult.Text = sreader.ReadToEnd();
			sreader.Close();
		}


	}
}
