Public MustInherit Class Device
    Protected MaintenanceQuestions As New ArrayList()

    Protected Sub New()
        Dim T As Type
        Dim attrs() As Attribute
        ' Find the actual type of this object
        T = Me.GetType()
        ' Check for the "Portable" attribute
        attrs = CType(T.GetCustomAttributes(GetType(PortableAttribute), False), Attribute())
        If attrs.Length = 1 Then
            MaintenanceQuestions.Add("Are the batteries good?")
        Else
            MaintenanceQuestions.Add("Is it plugged in?")
        End If
        MaintenanceQuestions.Add("Did you turn it on?")
    End Sub

    Public Sub DisplayQuestions()
        Dim s As String
        ' Display a list of maintenance questions.
        For Each s In MaintenanceQuestions
            Console.WriteLine(s)
        Next
    End Sub
End Class

' Note, the attribute class doesn't have any properties in this case. 
' It's just a marker on the object type to indicate it is portable
<AttributeUsage(AttributeTargets.Class)> Public Class PortableAttribute
    Inherits Attribute
End Class
