using System;
using System.Collections ;

namespace DeviceAttributesCS
{
	/// <summary>
	/// Summary description for Device.
	/// </summary>
	public abstract class Device
	{

		protected ArrayList MaintenanceQuestions = new ArrayList();

		public Device()
		{
			Type T;
			Attribute[] attrs;
			// Find the actual type of this object
			T = this.GetType();
			// Check for the "Portable" attribute
			attrs = (Attribute[])(T.GetCustomAttributes(typeof(PortableAttribute), false));
			if (attrs.Length == 1) 
			{
				MaintenanceQuestions.Add("Are the batteries good?");
			}
			else 
			{

				MaintenanceQuestions.Add("Is it plugged in?");
			}
			MaintenanceQuestions.Add("Did you turn it on?");
		}
	
		public void DisplayQuestions() 
		{
			// Display a list of maintenance questions.
			foreach(string s in MaintenanceQuestions) 
			{
				Console.WriteLine(s);
			}
		}
	}

	// Note, the attribute class doesn't have any properties in this case. 
	// It's just a marker on the object type to indicate it is portable
	[AttributeUsage(AttributeTargets.Class)] public class PortableAttribute:Attribute  
	{
	}

}
