' StictIsSlow - comparing VB.Net and C# performance
' Copyright 2002-2003 by Dan Appleman
Imports System.Diagnostics
Module Module1

    Dim TestArray As ArrayList

    Sub Test1()
        Dim x, loops As Integer

        Dim StartTime As Integer
        Dim Duration As TimeSpan
        Dim Result As String

        StartTime = Environment.TickCount
        For loops = 1 To 5000
            For x = 0 To 9999
                Result = TestArray(x)
            Next
        Next

        Duration = TimeSpan.FromMilliseconds(Environment.TickCount - StartTime)
        MsgBox("Total time is: " & Duration.ToString)


    End Sub

    Sub Test2()
        Dim x, loops As Integer

        Dim StartTime As TimeSpan
        Dim Duration As TimeSpan
        Dim Result As String
        GC.Collect()
        GC.WaitForPendingFinalizers()
        StartTime = Process.GetCurrentProcess().Threads(0).UserProcessorTime

        For loops = 1 To 5000
            For x = 0 To 9999
                Result = TestArray(x)
            Next
        Next

        Duration = Process.GetCurrentProcess().Threads(0).UserProcessorTime.Subtract(StartTime)
        MsgBox("Total time is: " & Duration.ToString)


    End Sub


    Sub Test3()
        Dim x, loops As Integer

        Dim StartTime As TimeSpan
        Dim Duration As TimeSpan
        Dim Result As String
        GC.Collect()
        GC.WaitForPendingFinalizers()
        StartTime = Process.GetCurrentProcess().Threads(0).UserProcessorTime

        For loops = 1 To 5000
            For x = 0 To 9999
                Result = TestArray(x).ToString
            Next
        Next

        Duration = Process.GetCurrentProcess().Threads(0).UserProcessorTime.Subtract(StartTime)
        MsgBox("Total time is: " & Duration.ToString)

    End Sub


    Sub Main()
        TestArray = New ArrayList(10000)
        Dim x, loops As Integer
        For x = 1 To 10000
            TestArray.Add(Str(x))
        Next
        Test1()
        Test2()
        Test3()
    End Sub

End Module
