using System;
using System.Runtime.InteropServices;

namespace StringLookerCS
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: Add code to start application here
			//
			int x;
			string s1 = "Hello";
			string s2  = s1;
			if( (object)s1 == (object)s2)  Console.WriteLine("s1 and s2 are Same object");
			// C# doesn't have a "trick" function like Mid
			// so the results here are obvious
			s1 = "J" + s1.Substring(1);
			Console.WriteLine(s1);
			Console.Write(s2);
			Console.ReadLine();
			// We can look at the actual data
			s1 = "Hello";
			s2 = s1;
			GCHandle gch  = GCHandle.Alloc(s1, GCHandleType.Pinned);
			IntPtr  i;
			i = gch.AddrOfPinnedObject();
			Byte[] DataArray= new Byte[10];
			Marshal.Copy(i, DataArray, 0, 10);
			Console.WriteLine("Contents of pinned string");
			for( x = 0; x<10; x++)
			{
				Console.Write(DataArray[x].ToString() + " ");
			}
			Console.ReadLine();
			// The following causes SERIOUS problems
			DataArray[0] += 2;
			Console.WriteLine("Before and after modifying pinned s1");
			Console.WriteLine(s1);
			Console.WriteLine(s2);
			Marshal.Copy(DataArray, 0, i, 10);
			if( (object)s1 == (object)s2) Console.WriteLine("s1 and s2 are Same object");
			Console.WriteLine(s1);
			Console.WriteLine(s2);
			string s3  = "Hello";
			Console.WriteLine(s3);
			gch.Free();
			Console.ReadLine();
			// If you need to get an unmanaged buffer, try this
			s1 = "Hello2";
			s2 = s1;
			i = Marshal.StringToHGlobalUni(s1);
			Console.WriteLine("Contents of s1 marshaled to unmanaged heap");
			Marshal.Copy(i, DataArray, 0, 10);
			for(x = 0; x<10; x++) 
			{
				Console.Write(DataArray[x].ToString() + " ");
			}
			Console.ReadLine();
			DataArray[0] += 2;
			Console.WriteLine(s1);
			Console.WriteLine(s2);
			Marshal.Copy(DataArray, 0, i, 10);
			s1 = Marshal.PtrToStringUni(i);
			if( (object)s1 != (object)s2) Console.WriteLine("s1 and s2 are not Same object");
			Console.WriteLine(s1);
			Console.WriteLine(s2);
			Marshal.FreeHGlobal(i);
			Console.ReadLine();
			Console.WriteLine("Unsafe test");
			UnsafeStringTest();
			Console.ReadLine();

		}
		// fixed uses GCHandle.Pin
		static unsafe void UnsafeStringTest() 
		{
			string s1 = "Hello3";
			string s2 = s1;
			fixed(char* pStr = s1) 
			{
				*pStr = 'J';
			}
			if( (object)s1 == (object)s2) Console.WriteLine("s1 and s2 are Same object");
			Console.WriteLine(s1);
			Console.WriteLine(s2);
			string s3 = "Hello3";
			Console.WriteLine(s3);
		}
	}
}
