' Example for "What Day Is It"
' Copyright 2001-2003 by Desaware Inc.

Imports System.Globalization
Module Module1

    Sub Main()
        Dim Calendars As New Collection()
        Calendars.Add(New GregorianCalendar())
        Calendars.Add(New HebrewCalendar())
        Calendars.Add(New HijriCalendar())
        Calendars.Add(New JapaneseCalendar())
        Calendars.Add(New JulianCalendar())
        Calendars.Add(New KoreanCalendar())
        Calendars.Add(New TaiwanCalendar())
        Calendars.Add(New ThaiBuddhistCalendar())

        Dim CurrentCalendar As Calendar
        Console.WriteLine("Today is: ")
        For Each CurrentCalendar In Calendars

            With CurrentCalendar
                Console.WriteLine(.ToString())
                Console.Write(System.Enum.Format(GetType(DayOfWeek), .GetDayOfWeek(Now), "G") & " ")
                Console.Write(Str(.GetMonth(Now)) & "/" & Str(.GetDayOfMonth(Now)) & "/" & Str(.ToFourDigitYear(.GetYear(Now))) & " era: " & Str(.GetEra(Now)))
                Console.WriteLine()
            End With
        Next
        Console.WriteLine()
        CurrentCalendar = CultureInfo.CurrentUICulture.Calendar
        Console.WriteLine("Your default calendar is: " & CurrentCalendar.ToString() & " type: " & System.Enum.GetName(GetType(GregorianCalendarTypes), CType(CurrentCalendar, GregorianCalendar).CalendarType))
        Dim OtherCalendars As Calendar()
        OtherCalendars = CultureInfo.CurrentUICulture.OptionalCalendars()
        If Not OtherCalendars Is Nothing Then
            Console.WriteLine("Your optional calendars are: ")
            For Each CurrentCalendar In OtherCalendars
                If TypeOf CurrentCalendar Is GregorianCalendar Then
                    Console.WriteLine(CurrentCalendar.ToString() & " type: " & System.Enum.GetName(GetType(GregorianCalendarTypes), CType(CurrentCalendar, GregorianCalendar).CalendarType))
                Else
                    Console.WriteLine(CurrentCalendar.ToString())
                End If
            Next
        End If

        Console.ReadLine()


    End Sub

End Module
